const express = require('express');
const { Bundle, Client } = require('node-osc');
const path = require('path');

const bodyParser = require('body-parser');
const app = express();

const oscClient = new Client('127.0.0.1', 3333);
const alive = [];
let fseq;

const server = require('http').Server(app);

app.use(bodyParser.json());
app.use(bodyParser.urlencoded({extended:true}));
app.use(express.static('./frontend/assets'));

app.get('/', function (req, res) {
   res.sendFile('./frontend/index.html', { root: path.resolve(__dirname + '/..') })
});

app.post('/json', function (req, res) {
	console.log(req.body);
	fseq = fseq ? fseq + 1 : 1;
	let oscBundle;
	if (req.body.event === 'touchend') {
		oscBundle = new Bundle(
			[ '/tuio/2Dcur', 'source', 'tangibles@127.0.0.1' ],
			[ '/tuio/2Dcur', 'alive' ],
			[ '/tuio/2Dcur', 'fseq', fseq ]
		);
		delete alive[req.body.changedTouches[0].identifier];
		if (alive.length === 0) {
			fseq = 0;
		}
		oscClient.send(oscBundle, () => {
			res.status(200).json(JSON.stringify(req.body));
		});
	} else {
		if (req.body.changedTouches && req.body.changedTouches.length && req.body.changedTouches.length > 0) {
			const touches = Object.keys(req.body.changedTouches);
			touchList = [];
			touches.forEach(touch => {
				const id = req.body.changedTouches[touch].identifier;
				touchList.push(id);
			});
			alive.filter(aliveElement => {
				return touchList.includes(aliveElement);
			});
			const aliveMessage = [ '/tuio/2Dcur', 'alive' ].concat(alive);
			touches.forEach(touch => {
				const id = req.body.changedTouches[touch].identifier;
				if (!alive.includes(id)) {
					alive.push(id);
					aliveMessage.push(id);
				}
			});

			oscBundle = new Bundle(
				[ '/tuio/2Dcur', 'source', 'tangibles@127.0.0.1' ],
				aliveMessage,
				[ '/tuio/2Dcur', 'fseq', fseq ]
			);
			touches.forEach(touch => {
				oscBundle.append(
					[
						'/tuio/2Dcur',
						'set',
						req.body.changedTouches[touch].identifier,
						req.body.changedTouches[touch].clientX / req.body.screenW,
						req.body.changedTouches[touch].clientY / req.body.screenH,
						0.0,
						0.0
					]
				);
			});
			oscClient.send(oscBundle, () => {
				res.status(200).json(JSON.stringify(req.body));
			});
		} else {
			res.status(400).send();
		}
	}
});

server.listen(5001, function () {
 console.log('Votre app est disponible sur localhost:5001 !')
});

