# objets tangibles - receiver

> Application basée sur Node.js et Express 4 qui reçoit des datagrammes TUIO et les transmet à une page web via web-sockets

## Description

Le projet fourni est composé de 2 parties:
* un backend
* un frontend

Le backend est une application Node.js basée sur Express; il officie comme récepteur de données TUIO et les renvoie vers le frontend au moyen d'un web-socket.

Le frontend est une page web, servie par le backend, qui reçoit les événements émis par le serveur grâce au web-socket.

Chaque partie est contenue dans le dossier correspondant.


## Pré-requis

* Installer Node.js (v16 ou v17)
* Installer les dépendances:

```sh
cd receiver
npm install
```


## Lancer le serveur

Dans le dossier du projet, lancer la commande suivante:

```sh
node ./backend/server.js
```

* La page du frontend sera accessible à l'adresse http://localhost:5000
* Le serveur écoute les messages TUIO sur le port UDP 3333.

## Tester la réception de messages TUIO

On utilise le simulateur TUIO pour envoyer des messages. Par défaut, celui-ci émet également sur le port UDP 3333.
Ce simulateur a été inclus à la racine du projet.

Sur GNU/linux, le simulateur peut être lancé avec la commande suivante:

```sh
java -Djavax.accessibility.assistive_technologies=" " -jar TuioSimulator.jar
```

Note: le laguage Java doit être installé sur la machine.



## État des lieux

Lors de la réception des messages TUIO, la page web calcule la distance entre chaque point enregistré (via théorème de Pythagore), et l'affiche en console (!! la console du navigateur, accessible via F12 sur la page web).

C'est à partir de ces distances entre points qu'on pourra déterminer si ils font partie d'un même groupe. Cette partie là n'est finalement pas fournie ce soir...


